/* tslint:disable */
/* eslint-disable */
/**
 * Swagger Example API
 * This is a sample server celler server.
 *
 * The version of the OpenAPI document: 1.0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import type { Configuration } from './configuration';
import type { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import globalAxios from 'axios';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from './common';
import type { RequestArgs } from './base';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, BaseAPI, RequiredError, operationServerMap } from './base';

/**
 * 
 * @export
 * @interface GormDeletedAt
 */
export interface GormDeletedAt {
    /**
     * 
     * @type {string}
     * @memberof GormDeletedAt
     */
    'time'?: string;
    /**
     * Valid is true if Time is not NULL
     * @type {boolean}
     * @memberof GormDeletedAt
     */
    'valid'?: boolean;
}
/**
 * 
 * @export
 * @interface ModelDocument
 */
export interface ModelDocument {
    /**
     * 
     * @type {boolean}
     * @memberof ModelDocument
     */
    'chunked'?: boolean;
    /**
     * 
     * @type {string}
     * @memberof ModelDocument
     */
    'content'?: string;
    /**
     * 
     * @type {string}
     * @memberof ModelDocument
     */
    'createdAt'?: string;
    /**
     * 
     * @type {GormDeletedAt}
     * @memberof ModelDocument
     */
    'deletedAt'?: GormDeletedAt;
    /**
     * 
     * @type {string}
     * @memberof ModelDocument
     */
    'description'?: string;
    /**
     * 
     * @type {number}
     * @memberof ModelDocument
     */
    'id'?: number;
    /**
     * 
     * @type {number}
     * @memberof ModelDocument
     */
    'libraryId'?: number;
    /**
     * 
     * @type {string}
     * @memberof ModelDocument
     */
    'title'?: string;
    /**
     * 
     * @type {string}
     * @memberof ModelDocument
     */
    'updatedAt'?: string;
    /**
     * 
     * @type {number}
     * @memberof ModelDocument
     */
    'userId'?: number;
}
/**
 * 
 * @export
 * @interface PkgResponseError
 */
export interface PkgResponseError {
    /**
     * 
     * @type {string}
     * @memberof PkgResponseError
     */
    'message'?: string;
}
/**
 * 
 * @export
 * @interface PkgResponsePaginated
 */
export interface PkgResponsePaginated {
    /**
     * 
     * @type {object}
     * @memberof PkgResponsePaginated
     */
    'Data'?: object;
    /**
     * 
     * @type {number}
     * @memberof PkgResponsePaginated
     */
    'Limit'?: number;
    /**
     * 
     * @type {number}
     * @memberof PkgResponsePaginated
     */
    'Page'?: number;
    /**
     * 
     * @type {number}
     * @memberof PkgResponsePaginated
     */
    'Total'?: number;
}

/**
 * DocumentsApi - axios parameter creator
 * @export
 */
export const DocumentsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary 删除文档
         * @param {string} id 文档 ID
         * @param {number} libraryId 资料库 ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        documentIdDelete: async (id: string, libraryId: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'id' is not null or undefined
            assertParamExists('documentIdDelete', 'id', id)
            // verify required parameter 'libraryId' is not null or undefined
            assertParamExists('documentIdDelete', 'libraryId', libraryId)
            const localVarPath = `/document/{Id}`
                .replace(`{${"Id"}}`, encodeURIComponent(String(id)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication BearerToken required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (libraryId !== undefined) {
                localVarQueryParameter['LibraryId'] = libraryId;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary 显示文档
         * @param {string} libraryId 资料库 ID
         * @param {string} documentId 文档 ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        libraryLibraryIdDocumentDocumentIdGet: async (libraryId: string, documentId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'libraryId' is not null or undefined
            assertParamExists('libraryLibraryIdDocumentDocumentIdGet', 'libraryId', libraryId)
            // verify required parameter 'documentId' is not null or undefined
            assertParamExists('libraryLibraryIdDocumentDocumentIdGet', 'documentId', documentId)
            const localVarPath = `/library/{LibraryId}/document/{DocumentId}`
                .replace(`{${"LibraryId"}}`, encodeURIComponent(String(libraryId)))
                .replace(`{${"DocumentId"}}`, encodeURIComponent(String(documentId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication BearerToken required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 获取当前账号的文档列表
         * @summary 获取文档列表
         * @param {number} page 页码
         * @param {number} libraryId 资料库 ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        libraryLibraryIdDocumentsGet: async (page: number, libraryId: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'page' is not null or undefined
            assertParamExists('libraryLibraryIdDocumentsGet', 'page', page)
            // verify required parameter 'libraryId' is not null or undefined
            assertParamExists('libraryLibraryIdDocumentsGet', 'libraryId', libraryId)
            const localVarPath = `/library/:LibraryId/documents`
                .replace(`{${"LibraryId"}}`, encodeURIComponent(String(libraryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication BearerToken required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (page !== undefined) {
                localVarQueryParameter['Page'] = page;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary 新建文档
         * @param {string} libraryId 标题
         * @param {string} title 标题
         * @param {string} [description] 描述
         * @param {string} [content] 文档内容
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        libraryLibraryIdDocumentsPost: async (libraryId: string, title: string, description?: string, content?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'libraryId' is not null or undefined
            assertParamExists('libraryLibraryIdDocumentsPost', 'libraryId', libraryId)
            // verify required parameter 'title' is not null or undefined
            assertParamExists('libraryLibraryIdDocumentsPost', 'title', title)
            const localVarPath = `/library/{LibraryId}/documents`
                .replace(`{${"LibraryId"}}`, encodeURIComponent(String(libraryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication BearerToken required
            await setApiKeyToObject(localVarHeaderParameter, "Authorization", configuration)

            if (title !== undefined) {
                localVarQueryParameter['Title'] = title;
            }

            if (description !== undefined) {
                localVarQueryParameter['Description'] = description;
            }

            if (content !== undefined) {
                localVarQueryParameter['Content'] = content;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * DocumentsApi - functional programming interface
 * @export
 */
export const DocumentsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = DocumentsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary 删除文档
         * @param {string} id 文档 ID
         * @param {number} libraryId 资料库 ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async documentIdDelete(id: string, libraryId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ModelDocument>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.documentIdDelete(id, libraryId, options);
            const index = configuration?.serverIndex ?? 0;
            const operationBasePath = operationServerMap['DocumentsApi.documentIdDelete']?.[index]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, operationBasePath || basePath);
        },
        /**
         * 
         * @summary 显示文档
         * @param {string} libraryId 资料库 ID
         * @param {string} documentId 文档 ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async libraryLibraryIdDocumentDocumentIdGet(libraryId: string, documentId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ModelDocument>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.libraryLibraryIdDocumentDocumentIdGet(libraryId, documentId, options);
            const index = configuration?.serverIndex ?? 0;
            const operationBasePath = operationServerMap['DocumentsApi.libraryLibraryIdDocumentDocumentIdGet']?.[index]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, operationBasePath || basePath);
        },
        /**
         * 获取当前账号的文档列表
         * @summary 获取文档列表
         * @param {number} page 页码
         * @param {number} libraryId 资料库 ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async libraryLibraryIdDocumentsGet(page: number, libraryId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PkgResponsePaginated>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.libraryLibraryIdDocumentsGet(page, libraryId, options);
            const index = configuration?.serverIndex ?? 0;
            const operationBasePath = operationServerMap['DocumentsApi.libraryLibraryIdDocumentsGet']?.[index]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, operationBasePath || basePath);
        },
        /**
         * 
         * @summary 新建文档
         * @param {string} libraryId 标题
         * @param {string} title 标题
         * @param {string} [description] 描述
         * @param {string} [content] 文档内容
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async libraryLibraryIdDocumentsPost(libraryId: string, title: string, description?: string, content?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<ModelDocument>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.libraryLibraryIdDocumentsPost(libraryId, title, description, content, options);
            const index = configuration?.serverIndex ?? 0;
            const operationBasePath = operationServerMap['DocumentsApi.libraryLibraryIdDocumentsPost']?.[index]?.url;
            return (axios, basePath) => createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration)(axios, operationBasePath || basePath);
        },
    }
};

/**
 * DocumentsApi - factory interface
 * @export
 */
export const DocumentsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = DocumentsApiFp(configuration)
    return {
        /**
         * 
         * @summary 删除文档
         * @param {string} id 文档 ID
         * @param {number} libraryId 资料库 ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        documentIdDelete(id: string, libraryId: number, options?: any): AxiosPromise<ModelDocument> {
            return localVarFp.documentIdDelete(id, libraryId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary 显示文档
         * @param {string} libraryId 资料库 ID
         * @param {string} documentId 文档 ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        libraryLibraryIdDocumentDocumentIdGet(libraryId: string, documentId: string, options?: any): AxiosPromise<ModelDocument> {
            return localVarFp.libraryLibraryIdDocumentDocumentIdGet(libraryId, documentId, options).then((request) => request(axios, basePath));
        },
        /**
         * 获取当前账号的文档列表
         * @summary 获取文档列表
         * @param {number} page 页码
         * @param {number} libraryId 资料库 ID
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        libraryLibraryIdDocumentsGet(page: number, libraryId: number, options?: any): AxiosPromise<PkgResponsePaginated> {
            return localVarFp.libraryLibraryIdDocumentsGet(page, libraryId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary 新建文档
         * @param {string} libraryId 标题
         * @param {string} title 标题
         * @param {string} [description] 描述
         * @param {string} [content] 文档内容
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        libraryLibraryIdDocumentsPost(libraryId: string, title: string, description?: string, content?: string, options?: any): AxiosPromise<ModelDocument> {
            return localVarFp.libraryLibraryIdDocumentsPost(libraryId, title, description, content, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * DocumentsApi - object-oriented interface
 * @export
 * @class DocumentsApi
 * @extends {BaseAPI}
 */
export class DocumentsApi extends BaseAPI {
    /**
     * 
     * @summary 删除文档
     * @param {string} id 文档 ID
     * @param {number} libraryId 资料库 ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    public documentIdDelete(id: string, libraryId: number, options?: AxiosRequestConfig) {
        return DocumentsApiFp(this.configuration).documentIdDelete(id, libraryId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary 显示文档
     * @param {string} libraryId 资料库 ID
     * @param {string} documentId 文档 ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    public libraryLibraryIdDocumentDocumentIdGet(libraryId: string, documentId: string, options?: AxiosRequestConfig) {
        return DocumentsApiFp(this.configuration).libraryLibraryIdDocumentDocumentIdGet(libraryId, documentId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 获取当前账号的文档列表
     * @summary 获取文档列表
     * @param {number} page 页码
     * @param {number} libraryId 资料库 ID
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    public libraryLibraryIdDocumentsGet(page: number, libraryId: number, options?: AxiosRequestConfig) {
        return DocumentsApiFp(this.configuration).libraryLibraryIdDocumentsGet(page, libraryId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary 新建文档
     * @param {string} libraryId 标题
     * @param {string} title 标题
     * @param {string} [description] 描述
     * @param {string} [content] 文档内容
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    public libraryLibraryIdDocumentsPost(libraryId: string, title: string, description?: string, content?: string, options?: AxiosRequestConfig) {
        return DocumentsApiFp(this.configuration).libraryLibraryIdDocumentsPost(libraryId, title, description, content, options).then((request) => request(this.axios, this.basePath));
    }
}



